
#include "udpcmd.h"
int bytes;

main(argc, argv)
    char** argv;
{
    struct hostent* h;
    struct sockaddr_in me, it;
    msg m;
    int  seq, i, sock, namelen;
    void catch();

    if (argc < 3) {
	printf("usage: %s host cmd\n", argv[0]);
	exit(0);
    }
    if ((sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) {
	perror("socket");
	exit(2);
    }
    if (!(h = gethostbyname(argv[1]))) {
	perror(argv[1]);
	exit(3);
    }
    /*
     * Fill out an address for the remote socket.  This is the DESTINATION 
     */
    bzero(&it, sizeof(it));
    it.sin_family = AF_INET;
    bcopy(h->h_addr, &it.sin_addr, h->h_length);
    it.sin_port = htons(PORT);

    for (m.m_buf[0]=0, i=2; i<argc; i++) {
	strcat(m.m_buf, argv[i]);
	strcat(m.m_buf, " ");
    }
    fprintf(stderr, "host: %s, command %s\n", argv[1], m.m_buf);

    if (sendto(sock, &m, sizeof(m), 0,(struct sockaddr *) &it, sizeof it) < 0) {
	perror("send failed");
	exit(6);
    }
    namelen = sizeof(it);
    alarm(30);
    signal(SIGALRM, catch);
    for (seq=0; ; ++seq) {
	recvfrom(sock, &m, sizeof(m), 0,(struct sockaddr *) &it, &namelen);
	m.m_seq = ntohl(m.m_seq);
	bytes += sizeof(m);
	m.m_size = ntohl(m.m_size);
	if (m.m_seq == -1) {
	    if (m.m_size)
		fprintf(stderr, "Error return was %#x\n", m.m_size);
	    break;
	}
	if (m.m_seq != seq) {
	    if (seq < m.m_seq)
		fprintf(stderr, "**> %d packet(s) lost\n", m.m_seq - seq);
	    else
		fprintf(stderr, "**> recvd seq=%d expected seq=%d\n", 
		m.m_seq, seq);
	    seq = m.m_seq;
	}
	printf("%.*s", m.m_size, m.m_buf);
	alarm(15);	/* wait a while but eventually time out */
    }
    catch();
}

void catch() 
{
    fprintf(stderr, "%d received\n", bytes);
}
