
#include "udpcmd.h"
struct sockaddr_in me, it;

main(argc, argv)
    char** argv;
{
    msg m;
    int sock, namelen, seq = 0;
    struct hostent* h;
    FILE* f;

    if ((sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) {
	perror("socket");
	exit(2);
    }
    if (argc > 1) {
	if (!(h = gethostbyname(argv[1]))) {
	    perror("gethost");
	    exit(3);
	}
    }
    else {
	if (!(h = gethostbyname("localhost"))) {
	    perror("gethost");
	    exit(3);
	}
    }
    bzero(me, sizeof(me));
    me.sin_family = AF_INET;
    me.sin_port = htons(PORT);
    bcopy(h->h_addr, &me.sin_addr, h->h_length);
    if (bind(sock,(struct sockaddr *) &me, sizeof(me)) < 0) {
	perror("bind");
	exit(3);
    }
    if (fork())
	exit(0);	/*DEBUG*/
    for ( ;; ) {
	int namelen = sizeof(it);
	int seq;
	register len;

	if (recvfrom(sock, &m, sizeof(m), 0,(struct sockaddr *) &it, &namelen /* , 0 */ ) < 0) {
	    perror("recvfrom");
	    exit(9);
	}
	if (!(f = popen(m.m_buf, "r")))
	    goto done;
	for (seq=0; len = getbuf(m.m_buf, f); ++seq) {
	    m.m_seq = htonl((long)seq);
	    m.m_size = htonl(len);
	    sendto(sock, &m, sizeof(m), 0,(struct sockaddr *) &it, namelen);
	}
done:
	m.m_size = htonl((pclose(f)>>8) & 0xff);
	m.m_seq = htonl(-1);
	sendto(sock, &m, sizeof(m), 0,(struct sockaddr *) &it, namelen);
    }
}


getbuf(s, f)
    char *s;
    FILE *f;
{
    static buf[MBUFSIZ];
    static usebuf = 0; 
    static len;
    register used;

    if (usebuf) {
	strncpy(s, buf, len);
	used = len;
    }
    else
	used = 0;
    for ( ;; ) {
	if (!fgets(buf, sizeof(buf)-1, f)) {
	    usebuf = 0;
	    return used;
	}
	buf[sizeof(buf)-1] = 0;
	if ((len = strlen(buf)) <= (MBUFSIZ - used)) {
	    strncpy(&s[used], buf, len);
	    used += len;
	}
	else {
	    usebuf = 1;
	    return used;
	}
    }
}
